#---------------------------------------------------------------------
# Example configuration for a possible web application.  See the
# full configuration options online.
#
#   https://www.haproxy.org/download/1.8/doc/configuration.txt
#
#---------------------------------------------------------------------

#---------------------------------------------------------------------
# Global settings
#---------------------------------------------------------------------
global
    # to have these messages end up in /var/log/haproxy.log you will
    # need to:
    #
    # 1) configure syslog to accept network log events.  This is done
    #    by adding the '-r' option to the SYSLOGD_OPTIONS in
    #    /etc/sysconfig/syslog
    #
    # 2) configure local2 events to go to the /var/log/haproxy.log
    #   file. A line like the following can be added to
    #   /etc/sysconfig/syslog
    #
    #    local2.*                       /var/log/haproxy.log
    #
    log         127.0.0.1 local2

    chroot      /var/lib/haproxy
    pidfile     /var/run/haproxy.pid
    maxconn     4000
    user        haproxy
    group       haproxy
    daemon

    # turn on stats unix socket
    stats socket /var/lib/haproxy/stats

    # Configure DH parameters
    ssl-dh-param-file /etc/haproxy/dhparam.pem

    # utilize system-wide crypto-policies
    ssl-default-bind-options ssl-min-ver TLSv1.2 no-tls-tickets #no-sslv3 no-tlsv10 no-tlsv11 no-tls-tickets
    ssl-default-bind-ciphers ECDHE-ECDSA-AES256-GCM-SHA384:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256
    # ssl-default-bind-ciphers PROFILE=SYSTEM
    ssl-default-server-ciphers PROFILE=SYSTEM


#---------------------------------------------------------------------
# common defaults that all the 'listen' and 'backend' sections will
# use if not designated in their block
#---------------------------------------------------------------------
defaults
    mode                    http
    log                     global
    option                  httplog
    option                  dontlognull
    option http-server-close
    option forwardfor       except 127.0.0.0/8
    option                  redispatch
    retries                 3
    timeout http-request    10s
    timeout queue           1m
    timeout connect         10s
    timeout client          1m
    timeout server          1m
    timeout http-keep-alive 10s
    timeout check           10s
    maxconn                 3000

frontend ca.{{ ansible_hostname }}
        bind [::]:80
        bind [::]:443 ssl crt /etc/haproxy/https-EC.chain.pem crt /etc/haproxy/https-RSA.chain.pem

        acl needs_tls path_beg -i /ui
        acl needs_tls path_beg -i /admin
        acl needs_tls path_beg -i /acme

        http-request redirect prefix /ui if { path / }
        http-request redirect scheme https if needs_tls !{ ssl_fc }

        http-response del-header 'X-Powered-By'
        http-response del-header 'Server'

        use_backend node_red_http

frontend tsa.{{ ansible_hostname }}
        mode tcp
        bind [::]:318
        use_backend node_red_tsa

backend node_red_http
        balance source
        option httpchk /health
        server ca 127.0.0.1:1880

backend node_red_tsa
        mode tcp
        balance source
        option tcp-check
        server ca 127.0.0.1:3180

listen stats
        bind [::]:8080
        # http-request use-service prometheus-exporter
        stats enable
        stats uri /metrics
        stats refresh 5s
